module Types where

data VMArguments =
  VMArguments {coreSize :: Maybe Int
              ,ramSize :: Maybe Int
              ,networkSpec :: Maybe String
              ,diskSize :: Maybe Int}
  deriving (Show)

data QvmNetwork
  = DefaultNAT
  | DefinedNetwork {netname :: String}
  | OvsBridge {bridge :: String}
  | OvsBridgeWithVLAN {bridge :: String
                      ,vlan :: Int}
  deriving (Show)

data QvmDisk
  = LocalImage String           -- local qcow2 image
  | HTTPImage String            -- URL to qcow2 image
  | SheepdogImage {sheepHost :: String
                  ,sheepPort :: String
                  ,sheepImageName :: String}
  deriving (Show)

data QvmDomain =
  QvmDomain {name :: String
            ,title :: String
            ,core :: Int
            ,ramSizeMB :: Int
            ,network :: QvmNetwork
            ,disk :: QvmDisk
            ,ipAddress :: Maybe String
            ,gateway :: Maybe String
            ,dns :: Maybe String}
  deriving (Show)

data DomainState
  = Running
  | Shutoff
  | Paused
  | Unknown
  deriving (Show, Eq)
